<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
/**
* PHP versions 4 and 5
*
* @category  Web Services
* @package   PageShot
* @author    Kuroneko Square <webmaster@kuroneko-square.net>
* @copyright 2009 Kuroneko Square
* @license   GPL
* @see       
* @filesource
*/
//-------------
define('PAGESHOT_CACHE_DIR', 'cache'); // cache directory
define('PAGESHOT_CACHE_TIME', '129600'); // cache time 1800=30minutes
//-------------
/**
 * Class for caching snapshots of websites from mozshot's Web service.
 *
 * @package PageShot
 * @author  Kuroneko Square <webmaster@kuroneko-square.net>
 * @access  public
 * @version Release: 0.0.1
 * @uses    mozshot
 */
//------------
class pageshot{
	var $uri;
	var $wx;
	var $wy;
	var $ix;
	var $iy;
	var $effect;
//------------
function pageshot() {
	$this->uri='';
	$this->wx=1100;
	$this->wy=1100;
	$this->ix=128;
	$this->iy=128;
	$this->effect=true;
}
//------------
function output(){
	if (preg_match('/^(https?|ftp)(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)$/', $this->uri)) {
		$img = $this->cache_operation();
		if(!empty($img)){
			Header("Content-type: image/png");
			echo $img;
		} else {
	        header( "HTTP/1.1 503 Service Unavailable" );
			echo 'Service Unavailable.';
			exit;
		}
	} else {
		echo 'Invalid Request.';
		exit;
	}
}
//------------
function cache_operation(){
	/*
	** get cache or new data
	*/
	$options = $this->uri.$this->wx.$this->wy.$this->ix.$this->iy.$this->effect;
	// If CACHE_DIR exist
	$cache_file = '';	// default
	if (PAGESHOT_CACHE_DIR != '') {
		$cache_file = PAGESHOT_CACHE_DIR .'/'. md5($options);
		$time_newest = @filemtime($cache_file);
		
		$timedif = @(time() - $time_newest);
		if ($timedif < PAGESHOT_CACHE_TIME) {
			// If-Modified-Since
			$request_headers = apache_request_headers();
			$etag = md5( $_SERVER["REQUEST_URI"] . $time_newest );
			
			if( $request_headers["If-Modified-Since"] ) {
			    $since = parse_http_date( $request_headers["If-Modified-Since"] );
			    if( $since["timestamp"] >= $time_newest ) {
			        header( "HTTP/1.1 304 Not Modified" );
			        header( "Etag: \"$etag\"" );
			        exit();
			    }
			}
			// Return cache
			$data = file_get_contents($cache_file);
		} else {
			// Create new data
			$data = file_get_contents($this->get_requesturi());
			if(!empty($data)){
				// save data as cache file
				if ($f = @fopen($cache_file, 'w')) {
					fwrite ($f, $data);
					fclose($f);
				}
			} else {
				$data = file_get_contents($cache_file);
			}
		}
	}else {
		$data = file_get_contents($this->get_requesturi());
	}
	return $data;
	require('parse_http_date.php');
}
//------------
function get_requesturi(){
	$mozshoturi = "http://mozshot.nemui.org/";
	return $mozshoturi."shot?".$this->uri;
}
//------------
}

//------------
/*$debug=1;
if($debug){
	$ObjS = new pageshot();
	$ObjS->uri="http://www.kuroneko-square.net/";
	$ObjS->output();
}*/
?>
